#!/bin/bash

CWD=$(pwd)

cd $(dirname $0)
if [ `uname -m` == "sparc64" ]; then
	NCPUS=`grep "^CPU.*online" /proc/cpuinfo | wc -l`
	if (( NCPUS == 1 )); then
		CPU_1=`sed -n '/^CPU.*online/{s/^CPU\(.*\):.*online/\1/p;q}' /proc/cpuinfo`
		CPU_B=$CPU_1
	elif (( NCPUS == 2 )); then
		# second CPU
		CPU_1=`awk -F 'U|:' '/^CPU.*online/{if ( i++ == 1 ) {print $2; exit;}}' /proc/cpuinfo`
		# first  CPU
		CPU_B=`sed -n '/^CPU.*online/{s/^CPU\(.*\):.*online/\1/p;q}' /proc/cpuinfo`
	elif (( NCPUS == 3 )); then
		# last CPU
		CPU_1=`awk -F 'U|:' '/^CPU.*online/{if ( i++ == 2 ) {print $2; exit;}}' /proc/cpuinfo`
		# second CPU
		CPU_B=`awk -F 'U|:' '/^CPU.*online/{if ( i++ == 1 ) {print $2; exit;}}' /proc/cpuinfo`
	elif (( NCPUS >= 4 )); then
		# 3-d CPU
		CPU_1=`awk -F 'U|:' '/^CPU.*online/{if ( i++ == 2 ) {print $2; exit;}}' /proc/cpuinfo`
		# second CPU
		CPU_B=`awk -F 'U|:' '/^CPU.*online/{if ( i++ == 3 ) {print $2; exit;}}' /proc/cpuinfo`
	else
		echo "ERROR number of cpus = $NCPUS";
		exit 1
	fi
else 
	NCPUS=`grep "processor.*:" /proc/cpuinfo | wc -l`
	if (( NCPUS == 1 )); then
		CPU_1=`awk '/processor.*:/{print $NF; exit;}' /proc/cpuinfo`
		CPU_B=`awk '/processor.*:/{print $NF; exit;}' /proc/cpuinfo`
	elif (( NCPUS == 2 )); then
		CPU_1=`awk '/processor.*:/{if ( i++ == 1 ) {print $NF; exit;}}' /proc/cpuinfo`
		CPU_B=`awk '/processor.*:/{print $NF; exit;}' /proc/cpuinfo`
	elif (( NCPUS == 3 )); then
		CPU_1=`awk '/processor.*:/{if ( i++ == 2 ) {print $NF; exit;}}' /proc/cpuinfo`
		CPU_B=`awk '/processor.*:/{if ( i++ == 1 ) {print $NF; exit;}}' /proc/cpuinfo`
	elif (( NCPUS >= 4 )); then
		CPU_1=`awk '/processor.*:/{if ( i++ == 2 ) {print $NF; exit;}}' /proc/cpuinfo`
		CPU_B=`awk '/processor.*:/{if ( i++ == 3 ) {print $NF; exit;}}' /proc/cpuinfo`
	else
		echo "ERROR number of cpus = $NCPUS";
		exit 1
	fi
fi

# Check threadirqs parameter for single cpu core hosts
if (( NCPUS == 1 )); then
	if ! uname -a | grep -q PREEMPT; then
		if ! cat /proc/cmdline | grep -q threadirqs; then
			exit 1
		fi
	fi	
fi

CMD="./bin/rt_model -F98 -l3 -1$CPU_1 -F50 -l50 -b$CPU_B -k10000 -t1123 -D50 -I50"
echo "./bin/startup" > ../scen.cp
echo "$CMD" >> ../scen.cp
cd $CWD
exit 0
