#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>

char *cmd = NULL;

char *my_name = NULL;
char host_name[64] = "\0";
char test_path[128] = "\0";
int num_net = 0;
int num_readers = 0;

#define MAX_CHILDS 20

pid_t child_pids[MAX_CHILDS];

char disk[32] = "\0";

static int usage(void)
{
//	printf("usage: %s -h [host name] -n [# net] -d [# disk]"
//			" -p [rt_model_tc path]\n", cmd);
	printf("usage: %s -p [rt_model_tc path] -r [# readers] -d [disk]\n", cmd);
	exit(1);
}

static void
arg_parsing(int argc, char **argv)
{
	int	opt;

//	while ((opt = getopt(argc, argv, "h:n:d:p:")) != EOF) {
	while ((opt = getopt(argc, argv, "r:p:d:")) != EOF) {
		switch (opt) {
//		case	'h':
//			strcpy(host_name, optarg);
//			break;
//		case	'n':
//			num_net = atoi(optarg);
//			break;
		case	'r':
			num_readers = atoi(optarg);
			break;
		case	'p':
			strcpy(test_path, optarg);
			break;
		case	'd':
			strcpy(disk, optarg);
			break;
		default:
			printf("arg_parsing: uncorrect argument\n");
			usage();
		}
	}

	return;
}

/*
static int
ping_host()
{
	int rval = 0;	
	char	str[64];
	sprintf(str, "ping -c 1 %s >2", host_name);
	rval = system(str);
	return rval;
}
*/
//#define BUF_READ 32 * 1024
#define BUF_SIZE 1024

static int read_disk()
{
	int f, sz = 1;
	char a[BUF_SIZE];

	if (disk[0] == '\0') sprintf(disk, "/dev/hda");

	f = open(disk, O_RDWR);
	if (f < 0) { 
		printf("open %s failed\n", disk);
		perror("failed");
		return 1;
	}
	while(sz >= 0) {
		sz = read(f, a, BUF_SIZE);
		if (!sz) {
			lseek(f, 0, SEEK_SET);
		}
	}
	perror("read loop");
	close(f);
	return 0;
}

static pid_t
create_childs()
{
	int i;
	pid_t pid = 1;
	char	str_disk[128];

	for(i = 0; i < num_readers; i++)
	{
		pid = fork(); 
		if (pid < 0) {
			perror("create_childs");
			return -1;
		}
		if (!pid) {
			read_disk();
		} else {
			printf("child %d %s\n", pid, str_disk);
			child_pids[num_net + i] = pid;
		}
	}

	return pid;

}

static int
rt_model_tc()
{
	int rval;
	char	str[256];
	sprintf(str, "%s", test_path);

	rval = system(str);

	return rval;
}

int main(int argc, char **argv, char **env)
{
	int rval, i;
	
	cmd = argv[0];

///	my_name = getenv("HOSTNAME");
//	printf("%p\n", my_name);
///	if (!my_name) {
///		printf("null HOSTNAME\n");
///		exit(1);
///	}

	arg_parsing(argc, argv);

///	if (host_name[0] == '\0') {
///		printf("no host name\n");
///		num_net = 0;
//		usage();
///	}

	if (test_path[0] == '\0') {
		printf("set rt_model_tc path\n");
		usage();
	}

	if (num_readers > MAX_CHILDS)
		num_readers = MAX_CHILDS;

	printf("# readers %d from %s test path %s\n", num_readers, disk, test_path);

///	if ((rval = ping_host()) != 0) {
///		printf("ping %s error\n", host_name);
///		num_net = 0;
//		exit(1);
///	}

	rval = (int)create_childs();
	if (!rval) return 0;

	rval = rt_model_tc();
	sleep(1);
	for(i = 0; i < MAX_CHILDS; i++) {
		if (child_pids[i]) {
			printf(" kill pid %d\n", child_pids[i]);
			kill(child_pids[i], SIGKILL);
		}
	}
	return rval;
}
