/*
 * rt_model_tc/src/getopt.c
 * Copyright (C) MCST 2015 Leonid Ananiev (leoan@mcst.ru)
 */

//#define _GNU_SOURCE
#include <sched.h>

#include "hrt_model.h"
#define RT_MOD_VER	"2.7"

//#define TRACING
#ifdef TRACING
//#define TRACING_WUP
//#define TRACING_MIS
//#define TRACING_LAT
//#define TRACING_ENT
//#define TRACING_DUR
#endif
#define STORE_EACH_RES 1
#ifdef EL_GET_TIMES
//#define USE_GET_TIMES
#endif

#ifndef __ptr128__
#define RT_MEMORY_POOL_SIZE 100000000LL
#else
#define RT_MEMORY_POOL_SIZE 25000000LL
#endif /* __ptr128 */

int		loop_num = MAX_TO_DO_DEF;
unsigned long	irq_cpu = -1;

int	in_number = 2;
char	devmpv_path[256] = "/dev/mpv/mpv_0_in:2";		/* in_number=3 */
int	thrds_num = 0;
int	num_intr_thrds = 0;
int	policy = SCHED_FIFO;
char	*policy_name = "FIFO";
int	prio = 97;
int	targ_wload = 10;
int	targ_omitt = 0;
thr_options_t	tho[MAX_THR_NUM];
long	old_rts_mask = 0, rts_mask;
int	do_set_rts_mask = 0;
char	comment[80];
int	verbose = 0;
int	test_res = 0;
int	enter_pass = 0;
int	max_wup_pass = 0;
int	system_cpu_mask;
int	cpu_nr;
int	intrpt_intrv_usec = 11237;	// interrupt interval for thread #0
long long work_by_user = 0;	// max work could be done in per msec - test arg
long	work_load0 = 0; /* thrad_0 loop duration (mcsec) without workload */
int	nodelay_read = 0;
int	wait_on_cpu = 0;
int	prn_header = 0;     // do print header line in res_rt_model.cvs file
int	use_poll = 0;
int	rt_cpu = 1;
static  pool_rt_t *rt_pool;
static  unsigned long long	start_time, end_time;
static	pthread_attr_t	pthr_attr;
static	pthread_attr_t	thr_attr;
static	pthread_mutex_t	start_fin_mx;
static	pthread_mutex_t	io_mx;
static	pthread_cond_t	started;
static	pthread_cond_t	finished;
static	volatile int	finish = 0;

static	long	fd_intrpt;
struct	pollfd	pollfd[1];
static  long	sum_misd_ints = 0;
static  long	misd_by_drv = 0;
static  long	max_misd_ints = 0;
static  long	max_ent = 0;
static  long	min_ent = MAXINT;
static	long long	sum_ent = 0;
static	int	num_ent = 0;
static  long	min_lat = MAXINT;
static  long	max_lat = 0;
static  long long	sum_lat = 0;
static  int	num_lat = 0;
static	char	*res_fname = "results/res_rt_mod.csv";
static  int	watch_preempt_d;
static  FILE	*watch_preempt_fd;
static	int	fd_log;
static  int	wokent_d;
static  char	old_wokent = '0';
#define LOG_FL_SZ	 1024 * 1024

#ifdef STORE_EACH_RES
static  int	num_each_res;
static  long long	*each_wup;
static  long long	*each_lat;
static  long long	*each_ent;
static  long long	*each_cntxsw;
static  long long	*each_bf_sch;
static  long long	*each_cntxswbf;
static  long long	*each_cntxswaf;
static  long long	*each_intw;
static  long long	*each_ints;
static  long long	*each_ints2;
static  long long	*each_mis;
static  long long	*each_app;
#endif
long long	large_array_sz= 8 * 1024 * 1024;
#ifdef TRACING
int trace_fd;
int trace_mrk;
#define MARK_SZ	64
char mark_str[MARK_SZ];
#endif

#ifdef USE_GET_TIMES
#define SZ_SCD_TIMES	20
unsigned long long *sche_times;
unsigned long long	sch_wakeup_mx;
unsigned long long  sch_enter_mx;
unsigned long long  sch_lock_mx;
unsigned long long  sch_cntxswb_mx;
unsigned long long  sch_cntxswe_mx;
unsigned long long  sch_woken_mx;
unsigned long long  sch_ip_mx;
unsigned long long  intr_w_mx;
unsigned long long  intr_s_mx;
unsigned long long	sch_wakeup;
unsigned long long  sch_enter;
unsigned long long  sch_lock;
unsigned long long  sch_cntxswb;
unsigned long long  sch_cntxswe;
unsigned long long  sch_woken;
unsigned long long  sch_ip;
unsigned long long  intr_w;
unsigned long long  intr_s;
#endif
static long calibr_thr_func(int thr_indx);

static void
print_tbl(int print_header)
{
	int i;
	struct utsname	info;
	time_t cur_time_sec;
	char *cur_time_str;
	FILE *res_fd;
	int cpu;
	int *prmpt_dis_mcs;
	int rval;

#define print_tbl_str(format, val_name, val)	\
	if (print_header) \
		fprintf(res_fd, "%s,", val_name); \
	else {\
		fprintf(res_fd, format, val); \
		if (verbose) {\
			printf("%20s=\t", val_name); \
			printf(format, val); \
			printf("\n"); \
		}\
	}


	res_fd = fopen(res_fname, "a");
	if (!res_fd) {
		printf("Cannot open %s\n", res_fname);
		return;
	}
	if (!print_header) {
		prmpt_dis_mcs = (int *)calloc(cpu_nr, sizeof(int));
		if (watch_preempt_fd) {
			for (i = 0; i < cpu_nr; i++) {
			rval = fscanf(watch_preempt_fd,
				"%*3c%d\t%d%*s\n", &cpu, &prmpt_dis_mcs[i]);
			}
		}
	}
	//print_tbl_str("%d,", "thrds_num", thrds_num);
	for (i=0; i < thrds_num; i++) {
		if (i < num_intr_thrds) {
			print_tbl_str("%d,", " intr THR#", i);
		} else {
			if (thrds_num > 2 && i == (thrds_num - 1)) {
				print_tbl_str("%d,", " log THR#", i);
			} else {
				print_tbl_str("%d,", " work THR#", i);
			}
		}
		print_tbl_str("%4.1f,", "wup_min(mcs)", tho[i].wup_min/1000.);
		print_tbl_str("%4.1f,", "wup_avg(mcs)",
			tho[i].wup_sum / tho[i].wup_num / 1000.);
		print_tbl_str("%4.1f,", "wup_max(mcs)", tho[i].wup_max/1000.);
		if (watch_preempt_fd) {
			print_tbl_str("%d,",
				"prmpt_dis(mcs)", prmpt_dis_mcs[i]);
		}
		if (i < num_intr_thrds) {
			if (max_ent == 0)
				min_ent = 0;
			print_tbl_str("%4.1f,", "min_ent(mcs)", min_ent / 1000.);
			print_tbl_str("%4.1f,", "avg_ent(mcs)",
				sum_ent / (num_ent ? :1) / 1000.);
			print_tbl_str("%4.1f,", "max_ent(mcs)", max_ent / 1000.);
			print_tbl_str("%4.1f,", "min_lat(mcs)", min_lat / 1000.);
			print_tbl_str("%4.1f,", "avg_lat(mcs)",
				sum_lat / (num_lat ? :1) / 1000.);
			print_tbl_str("%4.1f,", "max_lat(mcs)", max_lat / 1000.);
#ifdef EL_GET_TIMESxxxx
			if (sch_wakeup_mx && sch_enter_mx) {
				print_tbl_str("%4.1f,", "sch_ent-wup(mcs)", (sch_enter_mx - sch_wakeup_mx) / 1000.);
				print_tbl_str("%4.1f,", "sch_lock-ent(mcs)", (sch_lock_mx - sch_enter_mx) / 1000.);
				print_tbl_str("%4.1f,", "woken-wup(mcs)", (sch_woken_mx - sch_wakeup_mx) / 1000.);
				print_tbl_str("%4.1f,", "cntx_sw(mcs)", (sch_cntxswe_mx - sch_cntxswb_mx) / 1000.);
				print_tbl_str("%4.1f,", "cntxswB-sch_ent(mcs)", (sch_cntxswb_mx - sch_enter_mx) / 1000.);
				print_tbl_str("%4.1f,", "intr-wup(mcs)", intr_w_mx / 1000.  - sch_wakeup_mx / 1000.);
				print_tbl_str("%4.1f,", "intr_s-wup(mcs)", intr_s_mx / 1000. - sch_wakeup_mx / 1000.);
				print_tbl_str("%p,", "IPmax", sch_ip_mx);
			}
#endif
			print_tbl_str("%ld,", "misd_by_drv",  misd_by_drv);
			print_tbl_str("%ld,", "sum_misd_ints",  sum_misd_ints);
			print_tbl_str("%ld,", "max_misd_ints",  max_misd_ints);
		}else if (tho[i].back_grnd && !(thrds_num > 2 && i == (thrds_num - 1))) {
			print_tbl_str("%7.2f,", "INQ_AVRG", tho[i].inq_avrg);
		}
		print_tbl_str("%7lld,", "num_wups", tho[i].num_wups);
		print_tbl_str("%7lld,", "done_rqsts", tho[i].done_rqsts);
		print_tbl_str("%7lld,", "num_rqsts", tho[i].num_rqsts);
		if (tho[i].dur_min == MAXINT)
			tho[i].dur_min = 0;
		print_tbl_str("%7.3f,", "dur_avg(ms)", tho[i].dur_avrg / 1000.);
		print_tbl_str("%7.3f,", "dur_min(ms)", (float)tho[i].dur_min / 1000.);
		print_tbl_str("%7.3f,", "dur_max(ms)", (float)tho[i].dur_max / 1000.);
		print_tbl_str("%7.3f,", "dur_var(ms)", (float)(tho[i].dur_max - tho[i].dur_min) / 1000.);
	}
	for (i=0; i < thrds_num; i++) {
		print_tbl_str("%d,", "  args_THR#", i);
		print_tbl_str("%lx,", "cpu_mask", tho[i].cpu_mask);
		print_tbl_str("%s,", "polc", tho[i].policy_name);
		print_tbl_str("%d,", "prio", tho[i].prio);
		print_tbl_str("%ld,", "real_workload %", tho[i].targ_wload + work_load0 * 100 / intrpt_intrv_usec);
		print_tbl_str("%ld,", "work100perc(loops)", tho[i].work100perc);
	//	if (i != 0) {
	//		print_tbl_str("%lld,", "inq_max", tho[i].inq_max);
	//		print_tbl_str("%lld,", "done_rqsts%", tho[i].done_rqsts * 100 / (tho[i].num_rqsts + 1));
	//	}
	}
	print_tbl_str("%d,", "intrpt_intrv_usec", intrpt_intrv_usec);
	if(uname(&info) != -1){
	//	print_tbl_str("%s,", "sysname", info.sysname);
		print_tbl_str("%s,", "release", info.release);
	//	print_tbl_str("%s,", "version", info.version);
		print_tbl_str("%s,", "machine", info.machine);
	}
	time(&cur_time_sec);
	cur_time_str = (char *)malloc(128);
	ctime_r(&cur_time_sec, cur_time_str);
	cur_time_str[strlen(cur_time_str) - 1] = ' ';
	print_tbl_str("%s,", "date", cur_time_str);
	print_tbl_str("%d,", "cpu_nr", cpu_nr);
	print_tbl_str("%s,", "comment", comment);
	print_tbl_str("%d,", "loop_num", loop_num);
	print_tbl_str("%-7.1f,", "run_time(s)", (end_time - start_time) / 1000000.);
	if (irq_cpu != -1) {
		print_tbl_str("%-3x,", "irq_mask", (1<<irq_cpu));
	} else {
		print_tbl_str("%-3x,", "irq_cpu", 0xf);
	}
	print_tbl_str("0x%-5lx,", "rts_active", rts_mask);
	//print_tbl_str("%lld,", "work_load0(usec)", work_load0);
	print_tbl_str("%-s", " rtmod_ver", RT_MOD_VER);
// tests tst kern thr priors column; timer_kthread prior, cpu
	fprintf(res_fd, "\n");
	fclose(res_fd);
}
static void
print_res(void)
{
	struct stat stat_buf;

	if(prn_header || stat(res_fname, &stat_buf)){
		print_tbl(1);
	}
	print_tbl(0);
#ifdef STORE_EACH_RES
{	int i, j;
	int ming_wup, step_wup, step_lat, step_ent;
	FILE	*gist_fd;
	long *gist_wup, *gist_lat, *gist_ent;
	FILE	*each_fd;
	each_fd = fopen("results/each_res.csv", "w");
	if (!each_fd) {
		perror("open(results/each_res.csv");
	    exit(1);
	}
	fprintf(each_fd, "# wup; lat; ent; bf_sch; cntxsw; cntxswbf; cntxswaf; intw; ints; ints2; mis; app\n");
	for (i = 0; i < num_each_res; i++) {
		fprintf(each_fd, "%lld; %lld; %lld; %lld; %lld; %lld; %lld; %lld; %lld; %lld; %lld; %lld\n",
			each_wup[i], each_lat[i], each_ent[i], each_bf_sch[i], each_cntxsw[i], each_cntxswbf[i], each_cntxswaf[i], each_intw[i], each_ints[i], each_ints2[i], each_mis[i], each_app[i]);
		each_cntxswaf[i] = 0;
	}
	fclose(each_fd);
	gist_fd = fopen("results/gist.csv", "w");
#define N_STEP	200
	gist_wup = (long *)malloc(N_STEP * sizeof(long));
	gist_lat = (long *)malloc(N_STEP * sizeof(long));
	gist_ent = (long *)malloc(N_STEP * sizeof(long));
	for (i = 0; i < N_STEP; i++) {
		gist_wup[i] = 0;
		gist_lat[i] = 0;
		gist_ent[i] = 0;
	}
	ming_wup = tho[0].wup_min;
	step_wup = (tho[0].wup_max - ming_wup + N_STEP - 2) / (N_STEP - 1) + 1;
	step_lat = (max_lat - min_lat + N_STEP - 2) / (N_STEP - 1) + 1;
	step_ent = (max_ent - min_ent + N_STEP - 2) / (N_STEP - 1) + 1;
	for (i = 0; i < num_each_res; i++) {
		j = (each_wup[i] - ming_wup) / step_wup;
		if (j >= N_STEP || j < 0)
			continue;
		gist_wup[j]++;
		j = (each_lat[i] - min_lat) / step_lat;
		if (j >= N_STEP || j < 0)
			continue;
		gist_lat[j]++;
		j = (each_ent[i] - min_ent) / step_ent;
		if (j >= N_STEP || j < 0)
			continue;
		gist_ent[j]++;
	}
	fprintf(gist_fd, "# wup(ns); num_wup; lat(ns); num_lat; ent(ns); num_ent\n");
	for (i = 0; i < N_STEP; i++) {
		fprintf(gist_fd, "%d; %ld; %ld; %ld; %ld; %ld\n",
			ming_wup + i * step_wup, gist_wup[i],
			min_lat + i * step_lat, gist_lat[i],
			min_ent + i * step_ent, gist_ent[i]);
	}
	fclose(gist_fd);
}
#endif
}
void stack_touch(int *org_ptr) // for mlockall
{
	int loc;
	if ( (org_ptr - &loc) < 2000)
		stack_touch(org_ptr);
}

extern int set_deadline_policy(int policy, int intrpt_intrv_usec);

//
// set_prio_aff() prepare the thread for run:
// sets prio, cpu affinity and mlockall()
void
set_prio_aff(int policy, int prio, unsigned long cpu_mask_arg)
{
	int		rval = 0;
	unsigned long cpu_mask = cpu_mask_arg;
	struct sched_param   param;

	if (policy == SCHED_DEADLINE) {
		rval = set_deadline_policy(SCHED_DEADLINE, intrpt_intrv_usec);
		if (rval) {
			perror("sched_setattr() for test thread\n");
			test_res = 1;
			exit (1);
		}
	} else {
		param.sched_priority = prio;
		rval = sched_setscheduler( 0, policy, &param);
		if (rval) {
			perror("sched_setscheduler() for test thread\n");
			test_res = 1;
			exit (1);
		}
		rval = sched_setaffinity(0, sizeof(unsigned long), (cpu_set_t *)&cpu_mask);
		if (rval < 0) {
			perror("sched_setaffinity:");
			test_res = 1;
			exit (1);
		}
	}
	mlockall(MCL_CURRENT | MCL_FUTURE);
	stack_touch(&rval);
	/* performace counts debug 
	el_posix(EL_MISC_TO_DEBUG, 6, 0, 0x0, NULL);
	el_posix(EL_MISC_TO_DEBUG, 6, 1, 0x1, NULL);
	el_posix(EL_MISC_TO_DEBUG, 6, 2, 0x2c, NULL); // miss L1i
	el_posix(EL_MISC_TO_DEBUG, 6, 3, 0x1, NULL);
	*/
}
// log_func() is a workload function which makes logging
void
log_func(void)
{
	struct timeval tv;
	struct stat stat_buf;

	gettimeofday(&tv, NULL);
	fstat(fd_log, &stat_buf);
	if (stat_buf.st_size > LOG_FL_SZ)
		lseek(fd_log, 0, SEEK_SET);
	write(fd_log, &tv, sizeof(tv));
	fdatasync(fd_log);
}
// worker_func() is a universal workload function for any test thread.
// The loop body is short enough to be able create
// any low workload (10 %) for any short interrupt interval.
volatile long b = 0;
void
worker_func(long long work_volume, int thr_indx)
{
	volatile int	i;

	for (i = 0; i < work_volume; i+=2) {
		tho[thr_indx].w_array[i % large_array_sz] =
			(int)(10 * cos(tho[thr_indx].w_array[(i + (large_array_sz >> 1))
				% large_array_sz]));
	}
/*
	for (i = 0; i < work_volume; i+=2) {
		b += tho[thr_indx].w_array[i % large_array_sz] +
			tho[thr_indx].w_array[(i % large_array_sz) + 1];
	}
*/
}
// work_thr_func() is a main function for work thread.
// In rt_model a work thread is a thread awake by other thread
// but not by interrupt. Usualy work thread has lower priority and
// higher CPU workload then interrupt thread.
void *
work_thr_func(void *arg)
{
	int	thr_indx = (int)(long)arg;
	int	w_nxt;
	int	queue_sz;
	long long	work_load;
	unsigned long long	cur_time, end_work_time;
	long long	work_dur;
	zaiavka_t *zaiavka_for_next;
	zaiavka_t *zlist_from_prev;
	int	was_wait;
	long long	wup;
	struct timespec kernel_time;

	set_prio_aff(tho[thr_indx].policy, tho[thr_indx].prio, tho[thr_indx].cpu_mask);
	if (tho[thr_indx].policy == SCHED_DEADLINE) {
		printf("scheduler policy %s is set for work process %d\n",
		tho[thr_indx].policy_name, thr_indx);
	} else {
		printf("scheduler policy %s and priority %d is set for work process %d\n",
		tho[thr_indx].policy_name, tho[thr_indx].prio, thr_indx);
	}
	tho[thr_indx].pid = getpid();
	// Calibrate workload emulation function (loop iteration count)
	tho[thr_indx].work100perc = calibr_thr_func(thr_indx);
	work_load = tho[thr_indx].work100perc * tho[thr_indx].targ_wload / 100;

	// This syncronisation block keeps start of thread in line with thread start loop in main()
	pthread_mutex_lock(&start_fin_mx);
	pthread_cond_broadcast(&started);
	pthread_mutex_unlock(&start_fin_mx);
	while (finish <= num_intr_thrds) {
		pthread_mutex_lock(&tho[thr_indx].work_mx);
		if (tho[thr_indx].num_rqsts <= tho[thr_indx].done_rqsts) {
			/* handl postponed timer interrups now,
			 * postpon timer interrupts handling up to next call */
			el_user_tick(intrpt_intrv_usec);
			// It is recomended to use pthread cond wait/broadcast in RT tasks
			// but not signals, semaphores or other slow methods.
			pthread_cond_wait(&tho[thr_indx].do_work, &tho[thr_indx].work_mx);
			clock_gettime(CLOCK_REALTIME, &kernel_time);
			wup = (long long) kernel_time.tv_sec * NSEC_PER_SEC +
				kernel_time.tv_nsec - tho[thr_indx].wup_start;
			was_wait = 1;
			tho[thr_indx].num_wups++;
			if (wup > tho[thr_indx].wup_max)
				tho[thr_indx].wup_max = wup;
			if (wup < tho[thr_indx].wup_min)
				tho[thr_indx].wup_min = wup;
			tho[thr_indx].wup_sum += wup;
			tho[thr_indx].wup_num++;
		} else {
			was_wait = 0;
		}
		while ( tho[thr_indx].done_rqsts < tho[thr_indx].num_rqsts) {
			zlist_from_prev = tho[thr_indx].zaia_list;
			if (zlist_from_prev) {
				tho[thr_indx].done_rqsts++;
				tho[thr_indx].zaia_list = zlist_from_prev->z_list;
				zlist_from_prev->z_list = NULL; // needed ?
				free_area(zlist_from_prev, rt_pool);
			} else {
				printf("ERROR: done_rqsts %lld < num_rqsts %lld but zlist_from_prev=NULL\n",
					tho[thr_indx].done_rqsts, tho[thr_indx].num_rqsts);

			}
			pthread_mutex_unlock(&tho[thr_indx].work_mx);
#ifdef TRACING_DUR
			sprintf(mark_str, "WKRS %lld\n", work_load);
			write(trace_mrk, mark_str, MARK_SZ);
#endif
			// Start of job. Get start time.
			// Thread job is simulated here
			el_get_usec(&cur_time);
			if (thrds_num > 2 && thr_indx == (thrds_num - 1))
				log_func();
			else
				worker_func(work_load, thr_indx);
			// Done. Now get log_func() or worker_func() duration time.
			el_get_usec(&end_work_time);
			work_dur = end_work_time - cur_time;
#ifdef TRACING_DUR
			sprintf(mark_str, "WKRE %lld %d\n", end_work_time-cur_time, was_wait);
			write(trace_mrk, mark_str, MARK_SZ);
#endif
			if (tho[thr_indx].done_rqsts < (loop_num - 1) && tho[thr_indx].done_rqsts > 2) { // to awoid boundary effect
				if (work_dur > tho[thr_indx].dur_max) {
					if (tho[thr_indx].dur_max != 0 && (work_dur - (int)tho[thr_indx].dur_min) > 500 && verbose) {
#ifdef TRACING_DUR
						printf("VARw thr_indx=%d i=%lld dur_max=%lld dur_min=%lld max-avrg=%lld\n",
							thr_indx, tho[thr_indx].done_rqsts, work_dur, tho[thr_indx].dur_min,
							work_dur - (int)tho[thr_indx].dur_avrg, was_wait);
						sprintf(mark_str, "VAR %lld %d\n", work_dur - tho[thr_indx].dur_min, was_wait);
						write(trace_mrk, mark_str, MARK_SZ);
						mcst_trace_user();		/* mark for ltt */
						if (work_dur - tho[thr_indx].dur_min > 2000){
							write(trace_fd, "0", 1);
							el_set_rts_active(old_rts_mask);
							if (watch_preempt_fd > 0)
								write(watch_preempt_d, "0", 1);
							exit(0);
						}
#endif
					}
					tho[thr_indx].dur_max = work_dur;
				}
				tho[thr_indx].dur_avrg = (tho[thr_indx].dur_avrg
					* (tho[thr_indx].done_rqsts - 1) + work_dur)
					/ tho[thr_indx].done_rqsts;
				if (work_dur < tho[thr_indx].dur_min)
					tho[thr_indx].dur_min = work_dur;
			}
			pthread_mutex_lock(&tho[thr_indx].work_mx);
		}
		pthread_mutex_unlock(&tho[thr_indx].work_mx);
		// Data preprocessing done. Prepare and do wake up of next model thread
		if ((thrds_num - num_intr_thrds) > 1 && thr_indx < (thrds_num - 1) &&
							tho[thr_indx].done_rqsts < loop_num &&
							finish <= num_intr_thrds) {
			w_nxt = thr_indx + 1;
			pthread_mutex_lock(&tho[w_nxt].work_mx);
			// Some wake ups shold be ommitted as required by test option
			if (tho[w_nxt].omitted_wup++ >= tho[w_nxt].omitt_wup) {
				tho[w_nxt].omitted_wup = 0;
				if (tho[w_nxt].back_grnd && w_nxt < (thrds_num - 1)
						&& !(tho[w_nxt].forget_mis && tho[w_nxt].zaia_list)) {
					// It is recomended to use lib_mcst_rt get_area()
					// if multi-thread rt-task is running in multiprocessor environment
					zaiavka_for_next = (zaiavka_t *)get_area(rt_pool);
					if (zaiavka_for_next == NULL){
						printf("No space in rt_pool for next request. "
								"bg thr_indx=%d cpu=%d done_rqsts=%lld\n",
								thr_indx, tho[thr_indx].cpu, tho[thr_indx].done_rqsts);
						goto no_space;
					}
					tho[w_nxt].num_rqsts++;
					queue_sz = tho[w_nxt].num_rqsts - tho[w_nxt].done_rqsts;
					if (queue_sz < 0) printf("ERROR: queue_sz<0\n");
					if (tho[w_nxt].inq_max < queue_sz)
						tho[w_nxt].inq_max = queue_sz;
					tho[w_nxt].inq_avrg = (tho[w_nxt].inq_avrg * (tho[w_nxt].num_rqsts - 1) +
							queue_sz) / tho[w_nxt].num_rqsts;
					/* put zaiavka in FILO queue */
					zaiavka_for_next->z_list = tho[w_nxt].zaia_list;
					tho[w_nxt].zaia_list = zaiavka_for_next;
				}
				clock_gettime(CLOCK_REALTIME, &kernel_time);
				tho[w_nxt].wup_start =
					kernel_time.tv_sec * NSEC_PER_SEC + kernel_time.tv_nsec;
				pthread_cond_broadcast(&tho[w_nxt].do_work);
			}
		no_space:
			pthread_mutex_unlock(&tho[w_nxt].work_mx);
		}
	}
	return NULL;
}

// intrpt_thr_func() is a main function for interrupt thread - the thread
// which is awoken by interrupt. Usualy this thread has highest priority and
// lowest CPU workload for preprocessing data only and be ready for next interrupt.
void *
intrpt_thr_func(void *arg)
{
	int	thr_indx = (int)(long)arg;
	mpv_rd_inf_t	mpv_rd_info;
	mpv_intr_t		mpv_inf;
	int		rval = 0;
	int		i = 0 ;
	int			w_nxt;
	int		queue_sz;
	long long	work_load;
	zaiavka_t	*zaiavka_for1;
	int		prev_inpts_cnt_reg = 0;
	int		cur_mis_drv, prev_mis_drv = 0;
	mpv_intr_t	mpv_info;
	unsigned long long	cur_time, start_work, end_work_time, work_dur, cur_time1;
	struct timespec kernel_time, kernel_time0;
	long	misd_ints;
	long long	enter;
	unsigned long long	lat;
	long long	wup;
#ifdef TRACING_LAT
	unsigned long long	lat_lmax = 0;
#endif
#ifdef TRACING_ENT
	unsigned long long	ent_lmax = 0;
#endif
#ifdef TRACING_WUP
	unsigned long long	wup_lmax = 0;
#endif

	tho[thr_indx].pid = getpid();
	set_prio_aff(tho[thr_indx].policy, tho[thr_indx].prio, tho[thr_indx].cpu_mask);
	if (tho[thr_indx].policy == SCHED_DEADLINE) {
		printf("scheduler policy %s is set for work process %d\n",
		tho[thr_indx].policy_name, thr_indx);
	} else {
		printf("scheduler policy %s and priority %d is set for work process %d\n",
		tho[thr_indx].policy_name, tho[thr_indx].prio, thr_indx);
	}
    if (rt_cpu && tho[0].policy == SCHED_FIFO) {
	sleep(1);
        rval = el_set_cpu_rt(1);
        if (rval) {
            perror("EL_RT_CPU was not set\n");
        }
    }
	// Calibrate workload emulation function (loop iteration count)
	tho[thr_indx].work100perc = calibr_thr_func(thr_indx);
	work_load = tho[thr_indx].work100perc * tho[thr_indx].targ_wload / 100;
	if (thr_indx == 0) {
		pthread_mutex_lock(&start_fin_mx);
		pthread_cond_broadcast(&started);
		pthread_mutex_unlock(&start_fin_mx);
		// It is impotent to have HARDware interript.
		// SOFTware (high resolution timer) interrupt will produce soft results
		rval = ioctl(fd_intrpt, MPVIO_SET_INTERV, intrpt_intrv_usec);
		if (rval) {
			printf("ioctl MPVIO_SET_INTERV returns %d errno=%d\n", rval, errno);
			perror("err:");
			exit(1);
		}
		mpv_info.intr_timeout = intrpt_intrv_usec * 3;
		rval = ioctl(fd_intrpt, MPVIO_WAIT_INTR, &mpv_info);
		if (rval) {
			printf("ioctl MPVIO_WAIT_INTR returns %d errno=%d\n", rval, errno);
			perror("err:");
			exit(1);
		}
	}
	if(wait_on_cpu && thr_indx == 0) {
		rval = ioctl(fd_intrpt, MPVIO_WAIT_ONCPU, 3 * intrpt_intrv_usec);
		if (rval) {
			printf("ioctl MPVIO_WAIT_ONCPU returns %d errno=%d\n", rval, errno);
			perror("err:");
			exit(1);
		}
	}
	// do read to catch next but not previouse interrupt in main loop begining
	while ((rval = read(fd_intrpt,
		&mpv_rd_info, sizeof(mpv_rd_info))) < 0
			&& errno == EAGAIN) {
		};
#if 0
	if (rval < 0) {
		printf("= ERROR: read rval=%d errno=%d\n",
		    rval, errno);
		perror("read mpv");
		test_res = 1;
		exit (1);
	}
#endif
	prev_inpts_cnt_reg = mpv_rd_info.intpts_cnt;
#ifdef TRACING
	write(trace_fd, "1", 1);
#endif
	while (++i < loop_num) {
		/* handl postponed timer interrups now,
		 * postpon timer interrupts handling up to next call */
		el_user_tick(intrpt_intrv_usec);
#ifdef TRACING_DUR
	//	write(trace_fd, "1", 1);
		sprintf(mark_str, "MPV READ %d %lld %lld %lld\n", thr_indx, tho[0].num_wups, tho[1].num_wups, tho[2].num_wups);
		write(trace_mrk, mark_str, MARK_SZ);
#endif
//		prctl(0,1);
		clock_gettime(CLOCK_REALTIME, &kernel_time0);
		if (use_poll) {
			rval = poll(pollfd, 1, 20000);
			if (rval < 0) {
				printf("poll() returns %d errno=%d\n", rval, errno);
				perror("err:");
				exit(1);
			}
			if (rval == 0) {
				printf("poll() timeout\n");
				continue;
			}
			rval = ioctl(fd_intrpt, MPVIO_GET_INTR_INFO, &mpv_inf);
			if (rval) {
				printf("ioctl MPVIO_GET_INTR_INFO returns %d errno=%d\n", rval, errno);
				perror("err:");
				exit(1);;
			}
			mpv_rd_info.intr_appear_nsec= mpv_inf.intr_appear_nsec[in_number];
			mpv_rd_info.correct_counter_nsec = mpv_inf.correct_counter_nsec[in_number];
			mpv_rd_info.intpts_cnt= mpv_inf.intpts_cnt[in_number];
			mpv_rd_info.num_reciv_intr= mpv_inf.num_reciv_intr[in_number];
			mpv_rd_info.irq_enter_ns= mpv_inf.irq_enter_ns[in_number];
		} else {
			while ((rval = read(fd_intrpt,
				&mpv_rd_info, sizeof(mpv_rd_info))) < 0 &&
					errno == EAGAIN) {
				};
		}
		clock_gettime(CLOCK_REALTIME, &kernel_time);
		lat = mpv_rd_info.correct_counter_nsec;
#ifdef EL_WAKEUP_LAT
		el_posix(EL_WAKEUP_LAT, &wup, NULL, NULL, NULL);
#else
		if ((kernel_time0.tv_sec * NSEC_PER_SEC +
			kernel_time0.tv_nsec) < mpv_rd_info.intr_appear_nsec) {
			wup = (long long)kernel_time.tv_sec * NSEC_PER_SEC +
				kernel_time.tv_nsec -
				mpv_rd_info.intr_appear_nsec - lat;
			if (wup < 0) wup = 0;
		} else {
			/* read(fd_intrpt) was after interupt appiared
			 * and the was no wakeup() */
			wup = 0;
		}
#endif
		el_get_usec(&cur_time1); /* to get surrounding workload */
		tho[thr_indx].num_wups++;
#ifdef TRACING_WUP
#define MAXWUP	70000
		if ( i > 3 ){
			if (wup > wup_lmax || wup < 0){
				if (wup > wup_lmax) wup_lmax = wup;
				printf("%10d Max wup= %7lld cc %6d\n",
					i, wup,
					mpv_rd_info.correct_counter_nsec);
			}
			sprintf(mark_str, "WUP %lld\n", wup);
			write(trace_mrk, mark_str, MARK_SZ);
			//mcst_trace_user();		/* mark for ltt */
			if ( wup > MAXWUP){
				el_get_usec(&cur_time);
				write(trace_fd, "0", 1);
				printf("%d STP curt=%lld wup %lld\n",
				    i, cur_time, wup);
				//system("cat /sys/kernel/debug/tracing/trace > trc_`date +%H%M%S`");
				el_set_rts_active(old_rts_mask);
				if (watch_preempt_fd > 0)
					rval = write(watch_preempt_d, "0", 1);
				exit(0);
			}
		}
#endif
		// Number of inerrupts missed by user:
		misd_ints = mpv_rd_info.intpts_cnt - prev_inpts_cnt_reg - 1;
#ifdef TRACING_MIS
		if ( i > 3 ){
			if (misd_ints > 0) {
				printf("%10d MIS=%ld %ld\n", i, misd_ints, sum_misd_ints);
				sprintf(mark_str, "MIS %ld %ld\n", misd_ints, sum_misd_ints);
				write(trace_mrk, mark_str, MARK_SZ);
				if (sum_misd_ints >= 150){
					exit(0);
				}
			}
		}
#endif
		if (misd_ints < 0) misd_ints = 0; // overflow MPV register
		/* loop duration is a got + missed signals number */
		prev_inpts_cnt_reg = mpv_rd_info.intpts_cnt;
		if (i > 3) {
			sum_misd_ints += misd_ints;
			if (misd_ints > max_misd_ints) max_misd_ints = misd_ints;
		}
		// MPV controller reports number of interrupts which was sent to CPU
		// MPV driver reports number of interrupts processed by driver. Find diff:
		cur_mis_drv = mpv_rd_info.intpts_cnt - mpv_rd_info.num_reciv_intr - prev_mis_drv;
		if (cur_mis_drv < 0 || cur_mis_drv >= 2 >> 20 ) cur_mis_drv = 0; // overflow MPV register
		if (i > 10 && cur_mis_drv != 0){
			printf("i=%d mis_drv=%d irq_cnt =%d "
				"drv_rec=%d prev_mis_drv= %d\n",
				i, cur_mis_drv, mpv_rd_info.intpts_cnt,
				mpv_rd_info.num_reciv_intr, prev_mis_drv);
		}
		// do prognosis next interrupt time for expected miss interrupts counting
		prev_mis_drv = mpv_rd_info.intpts_cnt - mpv_rd_info.num_reciv_intr;
		// MPV controller  starts time counter when interrupt was sent to CPU; driver reads it
		enter = mpv_rd_info.irq_enter_ns;
#ifdef TRACING_ENT
#define MINENT	3000
#define MAXENT	470000
		sprintf(mark_str, "ENT %lld\n", enter);
		write(trace_mrk, mark_str, MARK_SZ);
		if (enter > 0 && enter < min_ent)
			printf("min ENT %lld\n", enter);
		if (i > 10 && enter < MINENT){
			printf("ENT < %d\n", MINENT);
			write(trace_fd, "0", 1);
			el_set_rts_active(old_rts_mask);
			exit(1);
		}
		if ( i > 5 && enter > ent_lmax){
			ent_lmax = enter;
			printf("max ENT %lld\n", enter);
			if (enter > MAXENT){
				printf("ENT > %d\n", MAXENT);
				write(trace_fd, "0", 1);
		//		(void)ioctl(fd_intrpt, MPVIO_SET_INTERV, 0);
		//		system("cat /debug/tracing/trace > trc_`date +%H%M%S`");
		//		ioctl(fd_intrpt, MPVIO_SET_INTERV, intrpt_intrv_usec);
				el_set_rts_active(old_rts_mask);
				if (watch_preempt_fd > 0)
					rval = write(watch_preempt_d, "0", 1);
				exit(1);
			}
		}
#endif
#ifdef TRACING_LAT
#define MAXLAT	50000
		sprintf(mark_str, "LAT %lld\n", lat);
		write(trace_mrk, mark_str, MARK_SZ);
		if ( i > 5 && lat > lat_lmax){
			lat_lmax = lat;
			printf("%10d LAT %7lld\n", i, lat);
			if (lat > MAXLAT){
				printf("LAT > %d\n", MAXLAT);
				write(trace_fd, "0", 1);
		//		(void)ioctl(fd_intrpt, MPVIO_SET_INTERV, 0);
		//		system("cat /debug/tracing/trace > trc_`date +%H%M%S`");
		//		ioctl(fd_intrpt, MPVIO_SET_INTERV, intrpt_intrv_usec);
				el_set_rts_active(old_rts_mask);
				if (watch_preempt_fd > 0)
					rval = write(watch_preempt_d, "0", 1);
				exit(1);
			}
		}
#endif
		tho[thr_indx].done_rqsts++;
		if (i > 1) {
#ifdef USE_GET_TIMES
			rval = el_get_schedule_times(sche_times,
					SZ_SCD_TIMES * sizeof(unsigned long long));
			if (rval) {
				sch_wakeup = 0;
				sch_enter = 0;
				sch_lock = 0;
				sch_cntxswb = 0;
				sch_cntxswe = 0;
				sch_woken = 0;
				sch_ip = 0;
				intr_w = 0;
				intr_s = 0;
			} else {
				sch_wakeup = sche_times[EL_GET_TIMES_WAKEUP];
				sch_enter = sche_times[EL_GET_TIMES_SCHED_ENTER];
				sch_lock = sche_times[EL_GET_TIMES_SCHED_LOCK];
				sch_cntxswb = sche_times[EL_GET_TIMES_CNTXB];
				sch_cntxswe = sche_times[EL_GET_TIMES_CNTXE];
				sch_woken = sche_times[EL_GET_TIMES_WOKEN];
				sch_ip = sche_times[EL_GET_TIMES_LAST_PRMT_ENAB];
				intr_w = sche_times[EL_GET_TIMES_INTR_W];
				intr_s = sche_times[EL_GET_TIMES_INTR_S];
			}
#endif
			if (lat < min_lat)
				min_lat = lat;
			if (lat > max_lat)
				max_lat = lat;
			sum_lat += lat;
			num_lat++;
			if (enter > 0 && enter < min_ent)
				min_ent = enter;
			if (enter > max_ent)
				max_ent = enter;
			sum_ent += enter;
			num_ent++;
			misd_by_drv += cur_mis_drv;
			tho[thr_indx].wup_sum += wup;
			tho[thr_indx].wup_num++;
			if (wup < tho[thr_indx].wup_min)
				tho[thr_indx].wup_min = wup;
			if (wup > tho[thr_indx].wup_max) {
				tho[thr_indx].wup_max = wup;
#ifdef USE_GET_TIMES
				sch_wakeup_mx = sch_wakeup;
				sch_enter_mx = sch_enter;
				sch_lock_mx = sch_lock;
				sch_cntxswb_mx= sch_cntxswb;
				sch_cntxswe_mx= sch_cntxswe;
				sch_woken_mx = sch_woken;
				sch_ip_mx = sch_ip;
				intr_w_mx = intr_w;
				intr_s_mx = intr_s;
#endif
			}
#ifdef STORE_EACH_RES
			each_wup[i] = wup;
			each_lat[i] = lat;
			each_ent[i] = enter;
			each_mis[i] = misd_ints;
			each_app[i] = mpv_rd_info.intr_appear_nsec / 1000;
#ifdef USE_GET_TIMES
			each_cntxsw[i] = sch_cntxswe - sch_cntxswb;
			each_bf_sch[i] = sch_enter - sch_wakeup;
			each_cntxswbf[i] = sch_cntxswb - sch_enter;
			each_cntxswaf[i] = sch_woken - sch_cntxswe;
			each_intw[i] = intr_w - sch_wakeup;
			each_ints[i] = intr_s - sch_wakeup;
			each_ints2[i] = intr_s - sch_woken;
#endif
#endif
		}
		el_get_usec(&start_work);
		worker_func(work_load, thr_indx);
		el_get_usec(&end_work_time);
		tho[thr_indx].num_rqsts++;
		if (tho[thr_indx].done_rqsts < (loop_num - 1) && tho[thr_indx].done_rqsts > 2) { // to awoid boundary effect
			work_dur = end_work_time - start_work;
			if (work_dur > tho[thr_indx].dur_max) {
				if (tho[thr_indx].dur_max != 0 && tho[thr_indx].done_rqsts > 10 && work_dur - (int)tho[thr_indx].dur_avrg > 500 && verbose) {
#ifdef TRACING_DUR
					printf("VARi thr_indx=%d i=%lld dur_max=%lld dur_min=%lld max-avrg=%lld\n",
						thr_indx, tho[thr_indx].done_rqsts, work_dur, tho[thr_indx].dur_min, work_dur - (int)tho[thr_indx].dur_avrg);
					sprintf(mark_str, "VAR %lld\n", work_dur - tho[thr_indx].dur_min);
					write(trace_mrk, mark_str, MARK_SZ);
					mcst_trace_user();		/* mark for ltt */
					if (work_dur - tho[thr_indx].dur_min > 10000){
						write(trace_fd, "0", 1);
						el_set_rts_active(old_rts_mask);
						if (watch_preempt_fd > 0)
							rval = write(watch_preempt_d, "0", 1);
						exit(0);
					}
#endif
				}
				tho[thr_indx].dur_max = work_dur;
			}
			tho[thr_indx].dur_avrg = (tho[thr_indx].dur_avrg
				* (tho[thr_indx].done_rqsts - 1) + work_dur)
				/ tho[thr_indx].done_rqsts;
			if (work_dur < tho[thr_indx].dur_min) tho[thr_indx].dur_min = work_dur;
		}
		if (i + sum_misd_ints >= loop_num)
			break;
		if (thrds_num == num_intr_thrds)
			continue;
		w_nxt = num_intr_thrds;
		// Data preprocessig is finished. Prepare and do wake up main worker thread
		pthread_mutex_lock(&tho[w_nxt].work_mx);
		if (tho[w_nxt].omitted_wup++ >= tho[w_nxt].omitt_wup &&
							finish <= num_intr_thrds) {
			zaiavka_for1 = (zaiavka_t *)get_area(rt_pool);
			if (zaiavka_for1 == NULL){
				printf("No space in rt_pool for next request. "
						"intrpt thr_indx=%d cpu=%d done_rqsts=%lld\n",
						thr_indx, tho[thr_indx].cpu, tho[thr_indx].done_rqsts);
				goto no_space;
			}
			tho[w_nxt].omitted_wup = 0;
			// Bakground thread is done_rqsts without request add in the list
			// beacouse this kind of thread is runnig permanently
//printf("b=%d fg=%d z=%p\n", tho[w_nxt].back_grnd, tho[w_nxt].forget_mis, tho[w_nxt].zaia_list);
			if (tho[w_nxt].back_grnd
					&& !(tho[w_nxt].forget_mis && tho[w_nxt].zaia_list)) {
				zaiavka_for1->z_list = tho[w_nxt].zaia_list;
				tho[w_nxt].zaia_list = zaiavka_for1;
				clock_gettime(CLOCK_REALTIME, &kernel_time);
				tho[w_nxt].wup_start =
					kernel_time.tv_sec * NSEC_PER_SEC + kernel_time.tv_nsec;
				tho[w_nxt].num_rqsts++;
				queue_sz = tho[w_nxt].num_rqsts - tho[w_nxt].done_rqsts;
				if (queue_sz < 0) printf("ERROR: queue_sz<0\n");
				if (tho[w_nxt].inq_max < queue_sz)
					tho[w_nxt].inq_max = queue_sz;
				tho[w_nxt].inq_avrg = (tho[w_nxt].inq_avrg * (tho[w_nxt].num_rqsts - 1) +
						queue_sz) / tho[w_nxt].num_rqsts;
			}
			pthread_cond_broadcast(&tho[w_nxt].do_work);
		}
	no_space:
		pthread_mutex_unlock(&tho[w_nxt].work_mx);
		if (i > 3) {
			/* get overhad (parasitic) workload */
			el_get_usec(&cur_time);
			work_load0 += cur_time - cur_time1 - work_dur;
		}
	}
	if (rt_cpu)
		el_set_cpu_rt(0);
	pthread_mutex_lock(&start_fin_mx);
	finish++;
	pthread_cond_broadcast(&finished);
	pthread_mutex_unlock(&start_fin_mx);
	return 0;
}

// calibr_thr_func() finds number of loops in worker_func() for 100% CPU workload.
long
calibr_thr_func(int thr_indx)
{
	unsigned long long	s_time, e_time;
	int		rval = 0, i;
	long long	t_usec;
	long long	work_pretest = 8000000;
	int	*large_array;
	long long work100perc;

	/* turn on mpv driver while cali,ration is performed */
	rval = ioctl(fd_intrpt, MPVIO_SET_INTERV, intrpt_intrv_usec);
	if (rval != 0) {
		perror("ioctl MPVIO_SET_INTERV");
		perror("err:");
		exit (1);
	}
	// Allocate an array for memory-intensive computations in worker_func()
	large_array = (int *)malloc(large_array_sz * sizeof(int));
	if (large_array == NULL) {
		printf("malloc for large_array_sz=%ld Mb failed\n",
			(long)large_array_sz * sizeof(int) / 1024 / 1024);
		exit(1);
	}
	for (i = 0; i < large_array_sz; i++)
		large_array[i] = 0;
	tho[thr_indx].w_array = large_array;
	i = 0;
more:	rval = el_get_usec(&s_time);
	if (rval != 0) {
		perror("el_get_usec()");
		perror("err:");
		exit (1);
	}
	worker_func(work_pretest, thr_indx);
	el_get_usec(&e_time);
	t_usec = e_time - s_time;
	if (t_usec <= intrpt_intrv_usec * 10){
		work_pretest *= 2;
		if (i++ > 100) {
			printf("Can't determin cpu load\n");
			exit(1);
		}
		goto more;
	}
	(void)ioctl(fd_intrpt, MPVIO_SET_INTERV, 0);
	work100perc = work_pretest * intrpt_intrv_usec / t_usec;
	if (work_by_user != 0) {
		if (verbose) {
			printf("work100%%=%lld loops in %d mcs for thread %d. ",
			work100perc, intrpt_intrv_usec, thr_indx);
			printf("Set by user work100perc=%lld\n", work_by_user);
		}
		work100perc = work_by_user;
	}
	return work100perc;
}
int
main(int argc, char **argv)
{
	long	rval;
	long	i;

//	prctl(0,0);	// 2.6.14. Do not trace in kernel the test init
	prog_argc = argc;
	prog_argv = argv;

	strcpy(comment, "-");
	tho[0].cpu_mask = 1;
	tho[0].policy = policy;
	tho[0].policy_name = policy_name;
	tho[0].prio = prio;
	tho[0].targ_wload = targ_wload;

	prog_getopt();
	if (tho[0].policy == SCHED_FIFO) {
		system("sysctl kernel.sched_rt_runtime_us=-1 > /dev/null");
	} else {
		system("sysctl kernel.sched_rt_runtime_us=950000 > /dev/null");
	}
	system("cpupower frequency-set -g performance > /dev/null 2>&1");
	system("for i in /proc/irq/[0-9]*; do echo 1 > $i/smp_affinity; done > /dev/null 2>&1");
	system("for i in /sys/devices/system/cpu/cpu*/cpuidle/state[12]/disable; do echo 1 > $i; done > /dev/null 2>&1");
	system("[ -d results ] || mkdir results");
#define LOG_FILE_PATH	"results/log_model"
	if (thrds_num > 2) {
		char *log_buf;
		fd_log = open(LOG_FILE_PATH, O_CREAT | O_WRONLY);
		log_buf = malloc(LOG_FL_SZ);
		if (log_buf == NULL) {
			printf("malloc %d bytes for log_buf failed\n", LOG_FL_SZ);
			exit(1);
		}
		memset(log_buf, 0, LOG_FL_SZ);
		if (fd_log < 0) {
			printf("Cat not open %s\n", LOG_FILE_PATH);
			perror("open(log_model)");
			test_res = 1;
			exit (1);
		}
		write(fd_log, log_buf, LOG_FL_SZ);
		free(log_buf);
	}
#ifdef TRACING
#define TRCING_PATH	"/sys/kernel/debug/tracing"
	trace_fd = open(TRCING_PATH"/tracing_on", O_WRONLY);
	if (trace_fd < 0) {
		printf("Cat not open %s\n", TRCING_PATH"/tracing_on");
		perror("open(TRCING_PATH)");
	}
	//trace_fd = open("/debug/tracing/tracing_on", O_WRONLY);
	write(trace_fd, "0", 1);
	trace_mrk = open("/sys/kernel/debug/tracing/trace_marker", O_WRONLY);

#endif
	watch_preempt_d = open("/proc/watch-preempt", O_RDWR);
	watch_preempt_fd = fdopen(watch_preempt_d, "rw");
	if (verbose && watch_preempt_fd < 0) {
			perror("open /proc/watch-preempt");
	}
	wokent_d = open("/proc/woken-time", O_RDWR);
	read(wokent_d, &old_wokent, 1);
#ifdef USE_GET_TIMES
	sche_times = (unsigned long long *)malloc(SZ_SCD_TIMES * sizeof(unsigned long long));
	write(wokent_d, "3", 1);
#else
	write(wokent_d, "1", 1);
#endif

	if (thrds_num == 0) {
		printf("Use at least one -1 -b or -B option\n");
		exit(1);
	}

	system_cpu_mask = el_get_cpus_mask();
        cpu_nr = el_get_cpus_num();
	// Create space for RT memory pool. It should be used for dynamic memory allocation in RT mode
	rval = get_pool_rt(&rt_pool, RT_MEMORY_POOL_SIZE, sizeof(zaiavka_t));
	if (rval) {
		printf("get_pool_rt(&rt_pool, 0x%llx, %zd) failed to allocate space for RT memory pool\n",
		       RT_MEMORY_POOL_SIZE, sizeof(zaiavka_t));
		printf("get_pool_rt returns %ld\n", rval);
		test_res = 1;
		exit (1);
	}
	loop_num++;
#ifdef STORE_EACH_RES
	num_each_res = loop_num;
	if (loop_num < num_each_res)
		num_each_res = loop_num;
	each_wup = (long long *)malloc(num_each_res * sizeof(long long));
	each_lat = (long long *)malloc(num_each_res * sizeof(long long));
	each_ent = (long long *)malloc(num_each_res * sizeof(long long));
	each_intw = (long long *)malloc(num_each_res * sizeof(long long));
	each_cntxsw = (long long *)malloc(num_each_res * sizeof(long long));
	each_bf_sch = (long long *)malloc(num_each_res * sizeof(long long));
	each_cntxswbf = (long long *)malloc(num_each_res * sizeof(long long));
	each_cntxswaf = (long long *)malloc(num_each_res * sizeof(long long));
	each_ints = (long long *)malloc(num_each_res * sizeof(long long));
	each_ints2 = (long long *)malloc(num_each_res * sizeof(long long));
	each_mis = (long long *)malloc(num_each_res * sizeof(long long));
	each_app = (long long *)malloc(num_each_res * sizeof(long long));
	/* touch to be it in RAM */
	for (i = 0; i < num_each_res; i++) {
		each_wup[i] = 0;
		each_lat[i] = 0;
		each_ent[i] = 0;
		each_intw[i] = 0;
		each_bf_sch[i] = 0;
		each_cntxsw[i] = 0;
		each_cntxswbf[i] = 0;
		each_cntxswaf[i] = 0;
		each_ints[i] = 0;
		each_ints2[i] = 0;
		each_mis[i] = 0;
		each_app[i] = 0;
	}
#endif

	// Start communication with MPV device
	if (nodelay_read) {
		fd_intrpt = open(devmpv_path, O_NDELAY);
	} else {
		fd_intrpt = open(devmpv_path, O_RDONLY);
	}
	if (fd_intrpt < 0) {
		printf("Cat not open %s. ERR=%ld. (Done 'modprobe mpv'?).\n",
			devmpv_path, fd_intrpt);
		perror("open MPV");
		test_res = 1;
		exit (1);
	}
	if (use_poll) {
		pollfd[0].fd = fd_intrpt;
		pollfd[0].events = POLLIN;
		pollfd[0].revents = 0;
	}
	(void)ioctl(fd_intrpt, MPVIO_SET_INTERV, 0);

	// Recommended style of programming for RT mode: mutex_lock-condition_bcast-mutex_unlock
	pthread_mutex_init(&start_fin_mx, NULL);
	pthread_mutex_init(&io_mx, NULL);
	pthread_cond_init(&started, NULL);
	pthread_cond_init(&finished, NULL);
	pthread_attr_init(&pthr_attr);
	// work threads starting
	pthread_attr_init(&thr_attr);
	pthread_attr_setscope(&thr_attr, PTHREAD_SCOPE_SYSTEM);
	pthread_attr_setscope(&pthr_attr, PTHREAD_SCOPE_SYSTEM);
	for (i=0; i < thrds_num; i++) {
		pthread_cond_init(&tho[i].do_work, NULL);
		pthread_mutex_init(&tho[i].work_mx, NULL);
		tho[i].num_rqsts = 0;
		tho[i].done_rqsts = 0;
		tho[i].inq_max = 0;
		tho[i].inq_avrg = .0;
		tho[i].wup_min = MAXLONG;
		tho[i].wup_max = 0;
		tho[i].wup_sum = 0;
		tho[i].wup_num = 1;
		tho[i].dur_min = MAXINT;
		tho[i].dur_max = 0;
		tho[i].dur_avrg = 0;
		tho[i].zaia_list = NULL;
		tho[i].omitted_wup = 0;
		tho[i].num_wups = 0;
	}
	// Start all child threads except the interrupt-handling thread
	// We want to ensure that all threads will be launched in line with this loop..

	// This mutex keeps the child thread waiting until we call condition wait
	pthread_mutex_lock(&start_fin_mx);
	for (i=1; i < thrds_num; i++) {
		// Create and launch child thread
		if (i < num_intr_thrds) {
			rval = pthread_create(&tho[i].thread_p, &thr_attr,
				&intrpt_thr_func, (void *)i);
		} else {
			rval = pthread_create(&tho[i].thread_p, &thr_attr,
				&work_thr_func, (void *)i);
			pthread_cond_wait(&started, &start_fin_mx);
		}
		if (rval) {
			perror("pthread_create work_thr_func\n");
			test_res = 1;
			exit(test_res);
		}
		// This cond_wait will unlock the mutex. The child thread will resume execution
		// and will issue cond_broadcast. The parent thread will be still paused until the
		// child thread releases the mutex
	}
	// start the thread which is done_rqsts by inerrupts
	rval = pthread_create(&tho[0].thread_p, &pthr_attr,
		intrpt_thr_func, 0);
	if (rval) {
		perror("pthread_create intrpt_thr_func,\n");
		test_res = 1;
		exit(test_res);
	}
	el_get_usec(&start_time);
	// Wait for finish
	rval = pthread_cond_wait(&started, &start_fin_mx);
	if (rval) {
		perror("pthread_cond_wait: started\n");
		test_res = 1;
		exit(test_res);
	}
	// Set real-time specifications mask
	old_rts_mask = el_get_rts_active();
	if (do_set_rts_mask) {
		el_set_rts_active(rts_mask);
	} else {
		rts_mask = old_rts_mask;
	}
	if (watch_preempt_fd > 0) {
		rval = write(watch_preempt_d, "1", 1);
		if (rval < 0)
			perror("write(watch_preempt_d, 1) ");
//		rval = write(watch_preempt_d, "t80n1", 6);
	}

	// the test is running

	while (finish < num_intr_thrds) {
		rval = pthread_cond_wait(&finished, &start_fin_mx);
		if (rval) {
			perror("pthread_cond_wait: finished\n");
			test_res = 1;
			exit(test_res);
		}
	}
	if (watch_preempt_fd > 0) {
		rval = write(watch_preempt_d, "0", 1);
		if (rval < 0)
			perror("write(watch_preempt_d, 0) ");
	}
	pthread_mutex_unlock(&start_fin_mx);
	for (i = num_intr_thrds; i < thrds_num; i++) {
		waitpid(tho[i].pid, NULL, 0);
	}
	el_get_usec(&end_time);
	if (rt_cpu)
		el_set_cpu_rt(0);
	if (do_set_rts_mask)
		el_set_rts_active(old_rts_mask);
	free_pool(rt_pool);
	work_load0 /= tho[0].wup_num;
	print_res();
	for (i = 0; i < num_intr_thrds; i++) {
		printf("Поток %ld был разбужен МПВ %10lld раз\n", i, tho[i].num_wups);
	}
	printf("Количество пропущенных прерываний драйвером:      %ld\n", misd_by_drv);
	printf("Количество пропущенных прерываний пользователем:  %ld\n", sum_misd_ints);
	// Test pass condition is depends from test option requerements
	if (enter_pass == 0 && max_wup_pass == 0){
		if(sum_misd_ints > 1) test_res = 1;
		for (i=1; i < thrds_num; i++) {
			if(tho[i].inq_avrg > 2){
				printf("queue %ld size=%7.2f expected < 2\n",
					i, tho[i].inq_avrg);
				test_res = 1;
			}
		}
	} else {
		if (enter_pass > 0  && max_ent / 1000 > enter_pass) {
				test_res = 1;
		}
		if (max_wup_pass > 0 && tho[0].wup_max > max_wup_pass * 1000) {
				test_res = 1;
		}
	}
	if (max_ent) {
		printf("Время входа в прерывание  мин = %7.3f макс = %7.3f средн = %7.3f (мкс)\n",
			min_ent / 1000., max_ent / 1000., sum_ent / num_ent / 1000.);
	}
	printf("Время задержки прерывания мин = %7.3f макс = %7.3f средн = %7.3f (мкс)\n",
		min_lat / 1000., max_lat / 1000.,  sum_lat / (num_lat ? :1) / 1000.);
	printf("Время активизации потока  мин = %7.3f макс = %7.3f средн = %7.3f (мкс)\n",
		tho[0].wup_min / 1000., tho[0].wup_max / 1000.,  tho[0].wup_sum / tho[0].wup_num / 1000.);
	if (test_res == 0)
		printf("PASS\n");
	else
		printf("FAIL\n");
	system("cpupower frequency-set -g schedutil  > /dev/null 2>&1");
	system("sysctl kernel.sched_rt_runtime_us=950000 > /dev/null");
	(void)ioctl(fd_intrpt, MPVIO_SET_INTERV, 0);
	close(fd_intrpt);
	close(fd_log);
	write(wokent_d, &old_wokent, 1);
	close(wokent_d);
	exit(test_res);
}
