#!/bin/bash
# usage irq_cpu0.sh mask_for_mpv mask_other_irq

CPU4ALL_IRQ=${1-2};
nocpu=1;
for cpu in `awk '/processor/{print $NF}' /proc/cpuinfo`; do
	(( nocpu && c1 == cpu )) && nocpu=0;
done;
if (($nocpu==1)); then
	echo Нет процессора $CPU4ALL_IRQ
	exit
fi
MSK_ALL=$(echo $(( 1 << $CPU4ALL_IRQ )) | awk '{printf("%x\n", $0)}')
for i in `awk '/fasteoi/{print int($1)}' /proc/interrupts`; do
	echo $MSK_ALL > /proc/irq/$i/smp_affinity;
	echo Прерывания irq$i привязаны к процессору $CPU4ALL_IRQ
done

CPU4MPV_IRQ=${1-0};
nocpu=1;
for cpu in `awk '/processor/{print $NF}' /proc/cpuinfo`; do
	(( nocpu && c1 == cpu )) && nocpu=0;
done;
if (($nocpu==1)); then
	echo Нет процессора $CPU4MPV_IRQ
	exit
fi
MSK_MPV=$(echo $(( 1 << $CPU4MPV_IRQ )) | awk '{printf("%x\n", $0)}')
IRQ_MPV=`awk '/mpv/{printf("%d\n", $1); exit}' /proc/interrupts`;
if [[ -z "$IRQ_MPV" ]]; then echo Нет МПВ в /proc/interrupts; exit 1; fi
#for i in 1 2 3 4 5; do
for i in 1 2 3; do
	echo $MSK_MPV > /proc/irq/$IRQ_MPV/smp_affinity;
	if (( 0x$(cat /proc/irq/$IRQ_MPV/smp_affinity) == 0x$MSK_MPV )); then
		echo Прерывания МПВ irq$IRQ_MPV привязаны к процессору $CPU4MPV_IRQ
		exit;
	fi
	mpv_gen -n1 -i0 > /dev/null 2>&1
done
echo Не удалось установить маску процессоров $MSK_MPV для прерывания $IRQ_MPV от МПВ.


